<template>
  <v-card :loading="loginIsPending">
    <v-card-title class="mb-0 pb-0">
      <v-row no-gutters align="start" justify="center">
        <v-col cols="12" style="text-align: center">
          <v-icon size="100" color="primary">mdi-account-circle</v-icon>
        </v-col>
        <v-col style="text-align: center" cols="12">
          <v-expand-transition mode="in-out">
            <p v-if="loginErrorMessage" class="overline error--text">
              {{ loginErrorMessage }}
            </p>
            <p v-else class="overline grey--text">
              Please Provide Your Credentials.
            </p>
          </v-expand-transition>
        </v-col>
      </v-row>
    </v-card-title>
    <v-form @submit.prevent="login">
      <v-card-text>
        <v-text-field label="Username" v-model="username" />
        <v-text-field type="password" label="Password" v-model="password" />
      </v-card-text>
      <v-card-actions>
        <v-btn
          :loading="loginIsPending"
          text
          block
          dark
          color="primary"
          type="submit"
        >
          Login
        </v-btn>
      </v-card-actions>
    </v-form>
  </v-card>
</template>
<script>
import { mapState, mapGetters } from "vuex";
//import TransitionExpand from '@/components/TransitionExpand.vue';

export default {
  components: {
    // TransitionExpand
  },
  data: () => ({
    username: undefined,
    password: undefined
  }),
  methods: {
    login() {
      // TODO: Form validation
      this.$store
        .dispatch("identity/login", {
          username: this.username,
          password: this.password
        })
        .then(() => {
          if (this.isAuthenticated) this.$router.push("/");
        });
    }
  },
  computed: {
    // The name "loginIsPending" and "loginErrorMessage" are dynamically created by `@/utils/createAsyncMutationType.js`
    ...mapState("identity", ["loginIsPending", "loginErrorMessage"]),
    ...mapGetters("identity", ["isAuthenticated"])
  }
};
</script>
